//----------------------------------------------------------------------------------------------------------------------
// Inline Functions
//----------------------------------------------------------------------------------------------------------------------
inline XMFLOAT3 _vectorcall operator+(XMFLOAT3 fA, XMFLOAT3 fB)
{
   XMFLOAT3 fC;
   XMStoreFloat3(&fC, XMLoadFloat3(&fA)+XMLoadFloat3(&fB));
   return fC;
}

inline XMFLOAT3 _vectorcall operator-(XMFLOAT3 fA, XMFLOAT3 fB)
{
   XMFLOAT3 fC;
   XMStoreFloat3(&fC, XMLoadFloat3(&fA)-XMLoadFloat3(&fB));
   return fC;
}

inline XMFLOAT3 _vectorcall operator*(XMFLOAT3 fA, float fB)
{
   XMFLOAT3 fC;
   XMStoreFloat3(&fC, XMLoadFloat3(&fA)*fB);
   return fC;
}

inline XMFLOAT3 _vectorcall operator*(float fA, XMFLOAT3 fB)
{
   XMFLOAT3 fC;
   XMStoreFloat3(&fC, fA*XMLoadFloat3(&fB));
   return fC;
}

inline XMFLOAT3& _vectorcall operator+=(XMFLOAT3& fA, XMFLOAT3 fB)
{
   XMStoreFloat3(&fA, XMLoadFloat3(&fA)+XMLoadFloat3(&fB));
   return fA;
}

inline XMFLOAT3& _vectorcall operator-=(XMFLOAT3& fA, XMFLOAT3 fB)
{
   XMStoreFloat3(&fA, XMLoadFloat3(&fA)-XMLoadFloat3(&fB));
   return fA;
}

inline XMFLOAT3& _vectorcall operator*=(XMFLOAT3& fA, float fB)
{
   XMStoreFloat3(&fA, XMLoadFloat3(&fA)*fB);
   return fA;
}

inline XMFLOAT2& _vectorcall operator*=(XMFLOAT2& fA, float fB)
{
   XMStoreFloat2(&fA, XMLoadFloat2(&fA)*fB);
   return fA;
}
