#include "axbreeze.h"

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   WORD wWidth = 640, wHeight = 480;

   // Initialize graphics, input, and audio
   SetDisplayMode(wWidth, wHeight);

   // Clear screen with blue color (ARGB)
   ClearDisplay(0xff0000ff);

   SetForeColor(0xffff0000);
   SetBackColor(0xff00ff00);
   DrawLine(600, -10, 10, 500);
   DrawRectangle(AXRECT(60, 10, 300, 100), true);
   SetTextDirection(0);
   SetTextAlignment(-1, -1);
   DrawText(20, wHeight/2-100, L"GetDisplayFeatureLevel = %x!", GetDisplayFeatureLevel());
   SetTextAlignment(0, -1);
   DrawText(wWidth/2, wHeight/2-50, L"GetDisplayFeatureLevel = %x.", GetDisplayFeatureLevel());
   SetTextAlignment(1, -1);
   DrawText(wWidth-2, wHeight/2, L"GetDisplayFeatureLevel = %x?", GetDisplayFeatureLevel());
   UpdateDisplay();

   // Wait 3 seconds for key or mouse
   WaitVirtualKeyDown(3.0f);

   // Clear screen again
   ClearDisplay(0xff0000ff);

   SetBackColor(0xff00fff0);
   SetRotationAngle(-30);
   SetLineThickness(8);
   DrawEllipse(160, 320, 300, 100, 0);

   WCHAR sentence[] = L"\f+37307373Fancy Drawing \f~+Effect Example! 0\f#00ff0f1\f#ff0f0f\f@2\f!3\f_\f~#45\f~!678\f#ffcd00\f~_\f-901\f~-23\f~@45\f$406\f#ff00cd7\f~$8\f@90";

   SetTextFont(L"Gabriola", 36);
   PrintText(40, 190, -1, -1, sentence);
   DrawRoundedRectangle(AXRECT(260, 400, 300, 100), AXSIZE(20, 20), true);
   UpdateDisplay();

   // Wait 5 seconds for key or mouse
   WaitVirtualKeyDown(5.0);

   SetColor(0xffff0000, 0xff000000);
   ClearDisplay();

   SetTextAlignment(-1, -1);
   SetRotationAngle(0);

   PrintText(10, 0, L"\f#0fff0fTotal camera number = %d", GetCameraTotal());
   PrintText(10, 30, L"\f#0fff0fTotal canvas number = %d", GetCanvasTotal());
   PrintText(10, 60, L"Total image number = %d", GetImageTotal());
   PrintText(10, 90, L"\f#0fff0fTotal light number = %d", GetLightTotal());
   PrintText(10, 120, L"Total music number = %d", GetMusicTotal());
   PrintText(10, 150, L"Total object number = %d", GetObjectTotal());
   PrintText(10, 180, L"Total particle number = %d", GetParticleTotal());
   PrintText(10, 210, L"Total skybox number = %d", GetSkyboxTotal());
   PrintText(10, 240, L"Total sound number = %d", GetSoundTotal());
   PrintText(10, 270, L"Total sprite number = %d", GetSpriteTotal());
   PrintText(10, 300, L"Total terrain number = %d", GetTerrainTotal());
   PrintText(10, 330, L"Total timer number = %d", GetTimerTotal());

   // Enter the game loop
   while(Looping())
   {
      UpdateDisplay();
      Sleep(100);
   }
}
