#include "axbreeze.h"
#define MAX_BUFFER 900*1024 // Buffer size

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   WORD wWidth = 1024, wHeight = 768;

   // Initialize graphics, input, and audio
   SetDisplayMode(wWidth, wHeight);

   // Load "..\\Image\\helloworld.jpg" to an image
   HANDLE hImage0 = LoadImage(L"..\\Image\\helloworld.jpg");

   // Paste part of the image to screen
   XMFLOAT3 fP(0.0f, 1.2f, 0.0f);
   XMFLOAT3 fR(-1.0f, 0.0f, 0.0f);
   DrawImage(hImage0, fP, fR, 2);

   SetTextAlignment(0, -1);
   DrawText(wWidth/2, 0, L"DRAW IMAGE AND PLAY SOUND");

   // Load and play wave sound
   HANDLE hSound0 = LoadSound(L"..\\Sound\\applaud.wav");
   PlaySound(hSound0);

   // Enter the game loop
   while(Looping())
   {
      UpdateDisplay();
      if(GetGameTime() > 3.0f) break;
   }

   // Show some useful information
   ClearDisplay();
   SetTextAlignment(0, -1);
   DrawText(512, 0, L"SHOW IMAGE, PRINT SOME INFORMATION, AND PLAY SOUND");
   SetTextAlignment(-1, -1);
   DrawText(1024/2-180, 768/2, L"Display size");
   DrawText(1024/2, 768/2, L"%d", GetDisplayClientSize().w);
   DrawText(1024/2+80, 768/2, L"%d", GetDisplayClientSize().h);
   DrawText(1024/2-180, 768/2+40, L"Window size");
   DrawText(1024/2, 768/2+40, L"%d", GetDisplayWindowSize().w);
   DrawText(1024/2+80, 768/2+40, L"%d", GetDisplayWindowSize().h);
   DrawText(wWidth/2, wHeight, 0, 1, L"Press Alt-F4 to exit...");

   // Set foreground color
   SetForeColor(CombineColor(255, 125, 0, 255));

   // This call is more convenient than the above ones
   DrawText(1024/2-180, 768/2+80, L"Monitor size    %d  %d", GetMonitorSize().w, GetMonitorSize().h);

   // Define an array to hold data
   BYTE pBuffer[MAX_BUFFER];

   // Load "diamond.png" to memory
   UINT uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Media\\diamond.png");

   // Do some cleaning work if the image is dirty (decryption)
   for(UINT i = 0; i < uSize; i++)
   {
      pBuffer[i] = pBuffer[i]; // Nothing is done here though
   }

   // Load image handle 5 from memory ("diamond.png")
   HANDLE hImage5 = LoadImage(pBuffer, uSize);

   // Paste full image to the screen
   SetTextSize(12);
   DrawText(10, 50, L"File size is %d", uSize);
   DrawImage(hImage5, 8, 65);

   // Paste part of the image to screen
   DrawImage(hImage5, 110, 70, { 0, 0, 40, 50 });
   DrawImage(hImage5, XMFLOAT3(-1.58f, 2.0f, 1.12f), XMFLOAT3(0, 0, 0));

   DrawText(200, 100, SoundExisting(hSound0) ? L"hSound0 exists" : L"hSound0 does NOT exist");
   DrawText(200, 120, ImageExisting(hImage0) ? L"hImage0 exists" : L"hImage0 does NOT exist");
   DrawText(200, 140, ImageExisting(hImage5) ? L"hImage5 exists" : L"hImage5 does NOT exist");
   Snooze(1.0f);

   // Load and loop sound three times (play four times totally)
   uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Sound\\jackpot.wav");
   HANDLE hSound1 = LoadSound(pBuffer, uSize);
   PlaySound(hSound1, 3);

   // Change mouse cursor shape
   SetMouseCursor(OCR_HAND); // Hand

   // Enter the game loop
   while(Looping())
   {
      UpdateDisplay();
      Sleep(500);
   }
}
