#include "axbreeze.h"

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   WORD wWidth = 1024, wHeight = 768;

   // Initialize graphics, input, and audio
   SetDisplayMode(wWidth, wHeight);

   // Clear screen with blue color
   ClearDisplay(0xff0000ff);

   // Set foreground color to yellow
   SetForeColor(0xffffff00);

   SetTextAlignment(0, 0);

   // Output text at screen center
   if(QueryController(0))
   {
      DrawText(wWidth/2, wHeight/2, L"Controller is connected");
      DrawText(wWidth/2, wHeight/2+40, L"You can test controller now");
   }
   else
   {
      DrawText(wWidth/2, wHeight/2, L"Controller is not connected");
   }

   SetTextAlignment(-1, 0);

   // Enter the game loop
   while(Looping())
   {
      if(PollGamepadUp(0)) DrawText(20, 40, L"PollGamepadUp");
      if(PollGamepadDown(0)) DrawText(20, 80, L"PollGamepadDown");
      if(PollGamepadLeft(0)) DrawText(20, 120, L"PollGamepadLeft");
      if(PollGamepadRight(0)) DrawText(20, 160, L"PollGamepadRight");
      if(PollButtonStart(0)) DrawText(20, 200, L"PollButtonStart");
      if(PollButtonBack(0)) DrawText(20, 240, L"PollButtonBack");
      if(PollButtonLeftThumb(0)) DrawText(20, 280, L"PollButtonLeftThumb");
      if(PollButtonRightThumb(0)) DrawText(20, 320, L"PollButtonRightThumb");
      if(PollButtonLeftShoulder(0)) DrawText(20, 360, L"PollButtonLeftShoulder");
      if(PollButtonRightShoulder(0)) DrawText(20, 400, L"PollButtonRightShoulder");
      if(PollButtonA(0)) DrawText(20, 440, L"PollButtonA");
      if(PollButtonB(0)) DrawText(20, 480, L"PollButtonB");
      if(PollButtonX(0)) DrawText(20, 520, L"PollButtonX");
      if(PollButtonY(0)) DrawText(20, 560, L"PollButtonY");
      if(GetLeftTrigger(0) > XINPUT_GAMEPAD_TRIGGER_THRESHOLD)
      {
         ClearDisplay(0xff0000ff);
         DrawText(wWidth/2, 120, L"GetLeftTrigger = %d", GetLeftTrigger(0));
         ShakeController(0, 65535, 0);
         Snooze(1.0f);
         ShakeController(0, 0, 0);
      }
      if(GetRightTrigger(0) > XINPUT_GAMEPAD_TRIGGER_THRESHOLD)
      {
         ClearDisplay(0xff0000ff);
         DrawText(wWidth/2, 160, L"GetRightTrigger = %d", GetRightTrigger(0));
         ShakeController(0, 0, 65535);
         Snooze(1.0f);
         ShakeController(0, 0, 0);
      }
      if(abs(GetLeftThumbX(0)) > XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE)
      {
         ClearDisplay(0xff0000ff);
         DrawText(wWidth/2, 240, L"GetLeftThumbX = %d", GetLeftThumbX(0));
      }
      if(abs(GetLeftThumbY(0)) > XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE)
      {
         ClearDisplay(0xff0000ff);
         DrawText(wWidth/2, 280, L"GetLeftThumbY = %d", GetLeftThumbY(0));
      }
      if(abs(GetRightThumbX(0)) > XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE)
      {
         ClearDisplay(0xff0000ff);
         DrawText(wWidth/2, 320, L"GetRightThumbX = %d", GetRightThumbX(0));
      }
      if(abs(GetRightThumbY(0)) > XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE)
      {
         ClearDisplay(0xff0000ff);
         DrawText(wWidth/2, 360, L"GetRightThumbY = %d", GetRightThumbY(0));
      }
      if(GetKeyStroke(0, 0) == VK_PAD_LTHUMB_UPLEFT)
      {
         DrawText(20, 600, L"VK_PAD_LTHUMB_UPLEFT");
      }
      if(GetKeyStroke(0, 0) == VK_PAD_RTHUMB_DOWNRIGHT)
      {
         DrawText(wWidth/2, 600, L"VK_PAD_RTHUMB_DOWNRIGHT");
      }
      UpdateDisplay(60);
   }
}
