#include "axbreeze.h"

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   // Initialize and clear the display
   SetDisplayMode(1024, 768, 1);
   SetForeColor(0xffffff00);
   SetBackColor(0xff0000ff);
   ClearDisplay();

   // Create and lock a specified image
   HANDLE hTarget = CreateImage(1000, 768);
   AXLOCK aLock = LockImage(hTarget);

   // Draw a red line directly to the locked image
   for(UINT i = 0; i < 767; i++)
   {
      aLock.p[i+i*aLock.w] = 0xffff0000; // Color format is ARGB
   }

   // Unlock specified image
   UnlockImage(hTarget);

   // Lock specified image again
   aLock = LockImage(hTarget);

   // Draw a green line with specified color
   for(UINT i = 0; i < 767; i++)
   {
      aLock.p[i+i*aLock.w+5] = 0xff00ff00; // Color format is ARGB
   }

   // Unlock specified image again
   UnlockImage(hTarget);

   DrawImage(hTarget);
   DrawText(1024/2, 50, 0, 0, L"Write to image directly");
   DrawText(100, 100, L"aLock.p = %p", aLock.p);
   DrawText(100, 200, L"aLock.w = %d", aLock.w);
   UpdateDisplay();

   // Save a screen shot
   HANDLE hImage1 = CaptureImage();
   SaveImage(L"..\\Media\\screen0.png", hImage1);
   DrawText(512, 768, 0, 1, L"Saved a screenshot!");

   // Enter the game loop
   while(Looping())
   {
      UpdateDisplay();
      Sleep(100);
      if(GetGameTime() > 3.0f) break;
   }

   //if(FileExisting(L"..\\Media\\screen0.png")) RemoveFile(L"..\\Media\\screen0.png");

   ClearDisplay();
   SetForeColor(0xffffff00);
   SetBackColor(0xff000000);

   HANDLE hImage3 = LoadImage(L"..\\Image\\helloworld.jpg");
   HANDLE hCanvas3 = LoadCanvas(L"..\\Media\\diamond.png");
   HANDLE hSound3 = LoadSound(L"..\\Sound\\applaud.wav");

   DrawText(100, 300, L"GetProcessorIdentity = %s", GetProcessorIdentity());
   DrawText(100, 350, L"GetNetworkIdentity = %s", GetNetworkIdentity());
   DrawText(100, 10, L"System time = %f", GetSystemTime());
   DrawText(500, 10, L"Game time = %f", GetGameTime());
   DrawText(100, 400, L"Image exists = %d", ImageExisting(hImage3));
   DrawText(100, 450, L"Canvas exists = %d", CanvasExisting(hCanvas3));
   DrawText(100, 500, L"Sound exists = %d", SoundExisting(hSound3));
   DrawText(100, 550, L"Image 1 exists = %d", ImageExisting(hImage1));
   RemoveImage(hImage3);
   RemoveSound(hSound3);
   DrawText(500, 400, L"Image exists = %d", ImageExisting(hImage3));
   DrawText(500, 450, L"Canvas exists = %d", CanvasExisting(hCanvas3));
   DrawText(500, 500, L"Sound exists = %d", SoundExisting(hSound3));
   DrawText(500, 550, L"Image 1 exists = %d", ImageExisting(hImage1));

   // Enter the game loop
   while(Looping())
   {
      UpdateDisplay(60);
      if(GetGameTime() > 10.0f) break;
   }

   // Paste image 1 to screen
   ClearDisplay();
   DrawImage(hImage1);
   SetCanvasTexture(XMFLOAT4(0.0f, 0.2f, 1.0f, 0.5f));
   DrawCanvas(hCanvas3, XMFLOAT3(0, 0.5, -0.53f));

   // Enter the game loop
   while(Looping())
   {
      ClearCanvas({ 0, 0, 1024, 70 }); // Clear this area for text
      DrawText(100, 20, L"System time = %.1f", GetSystemTime());
      DrawText(500, 20, L"Game time = %.1f", GetGameTime());
      UpdateDisplay(100);
   }
}
