#include "axbreeze.h"

vector<double> Re_data;
vector<double> Im_data;

void PrintArray(WCHAR* pFile, UINT uX, UINT uY)
{
   FILE* fw = _wfsopen(pFile, L"wt", _SH_DENYNO);
   if(fw)
   {
      for(UINT i = 0; i < uY; i++)
      {
	      for(UINT j = 0; j < uX; j++)
         {
            UINT index = i*uX+j;
	         fwprintf(fw, L"%7.1f,%7.1f ", Re_data[index], Im_data[index]);
         }
	      fwprintf(fw, L"\n");
      }
   }
}

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   // Initialize graphics, input, and audio
   SetDisplayMode(1024, 768);

   // Clear display with gradient colors
   ClearDisplay(0xaf00ffff, 0xff7f0f7f);

   UINT uSize[3] = { 10, 18, 1 };
   BYTE oScale[2] = { 2, 2 };
   FactorFourierTransform(uSize, oScale);
   PrintText(20, 20, L"Results are in \f#ff0000test-forward.txt\f~# and \f#ff0000test-inverse.txt");

   Re_data.resize(uSize[0]*uSize[1]);
   Im_data.resize(uSize[0]*uSize[1]);
   for(UINT i = 0; i < uSize[1]; i++) // Fill array with a sequence of numbers
   {
      for(UINT j = 0; j < uSize[0]; j++)
      {
         UINT index = i*uSize[0]+j;
	      Re_data[index] = index;
	      Im_data[index] = 0;
      }
   }

   FastFourierTransform(&Re_data[0], &Im_data[0], 1);
   PrintArray(L"..\\Bin\\test-forward.txt", uSize[0], uSize[1]);

   FastFourierTransform(&Re_data[0], &Im_data[0], -1);
   PrintArray(L"..\\Bin\\test-inverse.txt", uSize[0], uSize[1]);

   // Enter the game loop
   while(Looping())
   {
      UpdateDisplay(60);
   }
}
