#include "axbreeze.h"
#define MAX_BUFFER 900*1024 // 900K buffer size
void DrawWorldTriad(float fSize);

void CameraPosition()
{
   PrintText(8, 6, L"\f#ffff00FPS: \f#ff00ff%d", GetDisplayFrameRate());

   short sDx, sDy, sDz;
   const float fDs = 0.002f, fDt = 0.1f;
   static float fTheta = 0.5f*XM_PI, fPhi = 0.0f;
   float fR = 0.0f;

   GetMouseMove(MK_LBUTTON | MK_MBUTTON | MK_RBUTTON, sDx, sDy, sDz);
   fTheta -= fDs*sDy;
   fPhi -= fDs*sDx;
   fR = 5.0f*fDs*sDz;

   if(PollUpKey()) fTheta += fDt;
   if(PollDownKey()) fTheta -= fDt;
   if(PollLeftKey()) fPhi += fDt;
   if(PollRightKey()) fPhi -= fDt;
   if(PollShiftKey()) fR += fDt;
   if(PollControlKey()) fR -= fDt;
   if(fTheta < 1.0E-5f) fTheta = 1.0E-5f;
   if(fTheta > XM_PI-1.0E-5f) fTheta = XM_PI-1.0E-5f;

   XMFLOAT3 fP;
   GetCameraTarget(nullptr, fP);
   fP.y += fR;
   SetCameraTarget(nullptr, fP);
   SetCameraPosition(nullptr, 5.0f, fTheta, fPhi);
}

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   XMFLOAT3 fP;
   BYTE pBuffer[MAX_BUFFER];
   SetDisplayMode(1024, 768);

   UINT uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Image\\acorns.png");
   HANDLE hSprite0 = LoadSprite(pBuffer, uSize);
   SetSpritePosition(hSprite0, XMFLOAT3(-0.61f, -1.68f, -1.2f));
   SetSpriteScale(hSprite0, XMFLOAT2(2.5f, 2.5f));
   HANDLE hSprite1 = LoadSprite(L"..\\Image\\amanita-muscaria.png");
   SetSpritePosition(hSprite1, XMFLOAT3(2.41f, -0.58f, -0.6f));
   SetSpriteScale(hSprite1, XMFLOAT2(1.5f, 1.5f));
   HANDLE hSprite5 = LoadSprite(L"..\\Image\\imageCATLTV1G.png");
   SetSpritePosition(hSprite5, XMFLOAT3(-0.41f, -1.58f, -0.6f));
   SetSpriteScale(hSprite5, XMFLOAT2(3.5f, 3.5f));

   float fV[8][3] = { -1.0f, -1.0f, -1.0f, -1.0f, +1.0f, -1.0f, +1.0f, +1.0f, -1.0f, +1.0f, -1.0f, -1.0f,
                      -1.0f, -1.0f, +1.0f, -1.0f, +1.0f, +1.0f, +1.0f, +1.0f, +1.0f, +1.0f, -1.0f, +1.0f };
   UINT uColor[8] = { 0xFF00000F, 0xFF000F00, 0xFF0F0000, 0xFF000F0F, 0xFFFF0000, 0xFF00FF00, 0xFF0000FF, 0xFF00FFFF };

   SetSpriteBillboard(hSprite0, 1, 0, 0);
   SetSpriteBillboard(hSprite1, 1, 1, 0);
   SetSpriteBillboard(hSprite5, 1, 0, 1);

   // Enter the main loop
   while(Looping())
   {
      ClearDisplay(0xff1f001f);
      CameraPosition();
      float fT[8][3];
      for(UINT i = 0; i < 8; i++)
      {
         fT[i][0] = fV[i][0]+fP.x;
         fT[i][1] = fV[i][1]+fP.y;
         fT[i][2] = fV[i][2]+fP.z;
      }
      DrawBox((XMFLOAT3*)fT, uColor);
      DrawRectangle(XMFLOAT3(-1.5f+fP.x, 1.0f+fP.y, -1.1f+fP.z), XMFLOAT3(1, 0, 0), XMFLOAT3(0, 0, 1), XMFLOAT2(2.0f, 2.0f), uColor);
      DrawSprite();
      DrawWorldTriad(1.4375);
      DrawText(150, 10, L"Sprite billboarding is enabled, press arrow keys");
      GetCameraPosition(nullptr, fP);
      PrintText(150, 60, L"CameraPosition = %f, %f, %f", fP.x, fP.y, fP.z);
      GetCameraTarget(nullptr, fP);
      PrintText(150, 100, L"CameraTarget = %f, %f, %f", fP.x, fP.y, fP.z);
      PrintText(150, 140, L"Camera target distance \f#ff0000%f", GetCameraRadialDistance(nullptr));
      PrintText(150, 720, L"Camera view angle \f#ff0000%.1f\f~# degrees", GetCameraViewAngle(nullptr)*180/XM_PI);
      UpdateDisplay(60);
   }
}
