#include "axbreeze.h"

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   SetDisplayMode(1024, 768);
   SetCameraPosition(nullptr, XMFLOAT3(0.0f, -50, 20));
   SetLightPosition(nullptr, XMFLOAT3(15, 0, 15));
   SetLightSize(nullptr, XMFLOAT2(25, 25), 5);
   SetLightType(nullptr, 3);
   DisableAutoShadowing(true);
   //DisableSolidFilling(true);
   SetLightColor(nullptr, XMFLOAT3(1, 1, 1), 0.25);
   auto hObject0 = LoadObject(L"..\\Model\\LilyPT0.3ds", 0.5f);
   auto hObject1 = LoadObject(L"..\\Model\\ikea_lack.obj", 0.25f);
   auto mWorld1 = XMMatrixMultiply(XMMatrixRotationX(0.5f*XM_PI), XMMatrixTranslation(10, 0, -20));
   SetObjectTransform(hObject1, mWorld1);
   XMFLOAT3 fP(0, 0, 0), fD(0, 0, 1);

   // Enter the main loop
   while(Looping())
   {
      ClearDisplay();
      DrawObject(hObject0);
      DrawObject(hObject1);
      TurnCamera(nullptr, XMFLOAT3(0, 0, 1), 0.0005f);
      TurnLight(nullptr, fP, fD, -0.002f);
      DrawLightGeometry(nullptr, 0.5, 3, 5, 3);
      UpdateDisplay(0);
   }
}
