#include "axbreeze.h"
void DrawWorldTriad(float fSize);

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   SetDisplayMode(1024, 768);
   WCHAR* pSource[6] = { L"..\\Image\\skybox00_u.jpg", L"..\\Image\\skybox01_l.jpg",
                         L"..\\Image\\skybox02_f.jpg", L"..\\Image\\skybox03_r.jpg",
                         L"..\\Image\\skybox04_b.jpg", L"..\\Image\\skybox05_d.jpg" };
   auto hSkybox0 = LoadSkybox(XMFLOAT3(500.0f, 500.0f, 500.0f), pSource);
   auto hTerrain0 = LoadTerrain(XMFLOAT3(40, 40, 6), L"..\\Media\\Heightmap.jpg");
   WCHAR* pTerrain[5] = { L"..\\Media\\snow.png", L"..\\Media\\dirt.png", L"..\\Media\\stone.png",
                          L"..\\Media\\grass.png", L"..\\Media\\blend.jpg" };
   SetTerrainTexture(hTerrain0, pTerrain);
   SetTerrainTiling(hTerrain0, XMFLOAT2(3, 3));
   SetTerrainPosition(hTerrain0, XMFLOAT3(-20, -20, -5));
   SetCameraDirection(nullptr, XMFLOAT3(0, 1, -0.25));
   SetFogColor(XMFLOAT4(0.75, 0.75, 0.75, 0.8125));

   // Enter the main loop
   while(Looping())
   {
      ClearDisplay(0);
      DrawSkybox(hSkybox0);
      DrawTerrain(hTerrain0);
      DrawWorldTriad(0.25);
      TurnCamera(nullptr, XMFLOAT3(0, 0, 1), 0.0025f);
      UpdateDisplay(60);
   }
}
