#include "axbreeze.h"
#include "resource.h"

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   // Set title and icon for current window
   SetWindowTitle(L"Hello World");
   SetWindowIcon(L"IDI_ICON1");

   // Initialize the display
   SetDisplayMode(1024, 768);
   HANDLE hCanvas0 = GetCanvasCurrent();

   // Hide and change mouse pointer
   SetTextAlignment(0, 0);
   DrawText(1024/2, 50, L"CHANGE MOUSE CURSOR");
   DrawText(1024/2, 768/2, L"Press any key to continue");
   UpdateDisplay();

   SetMouseCursor(CROSSHAIR);
   SetMousePosition(1024/2, 20);

   // Update screen
   UpdateDisplay();

   // Enter the main loop
   while(Looping())
   {
      if(PollVirtualKey(VK_SPACE) || GetMouseButton() == VK_LBUTTON)
      {
         SetWindowIcon(IDI_ICON2);
         SetMouseCursor(OCR_HAND); // Change cursor to hand
         ClearDisplay();
         DrawText(1024/2, 768/2, L"Press Escape key or Right mouse button to continue");
         UpdateDisplay();
      }
      if(PollVirtualKey(VK_ESCAPE) || GetMouseButton() == VK_RBUTTON) break;
      Sleep(100);
   }

   // Set foreground to red and background to light blue
   SetForeColor(0xFFFF0000);
   SetBackColor(0xFF7777FF);

   // Clear screen with background color
   ClearDisplay();

   // Load canvas number 1 from resource
   HANDLE hCanvas1 = LoadCanvas(L"BLUEIMG", -1);

   // Set the current canvas to 1 (has been created by LoadCanvas)
   SetCanvasCurrent(hCanvas1);

   SetTextSize(7);
   // Print text to canvas 1
   PrintText(0, 0, -1, -1, L"Current canvas handle is %p", GetCanvasCurrent());

   // Update screen
   UpdateDisplay();
   SetTextSize(32);
   SetCanvasCurrent(hCanvas0);

   // Enter the main loop
   while(Looping())
   {
      SetTextAlignment(-1, -1);
      if(PollVirtualKey(VK_SPACE) || GetMouseButton() == VK_LBUTTON)
      {
         ClearDisplay();
         DrawText(112, 40, L"Rendered to canvas 1");
         DrawCanvas(hCanvas1, 100, 200, 3);
      }
      if(GetMouseButton() == VK_RBUTTON)
      {
         ClearDisplay();
         PrintText(10, 0, L"Current canvas handle is \f#ffff00%p", GetCanvasCurrent());
         DrawText(612, 40, L"Render to canvas 0");
      }
      SetTextAlignment(0, 1);
      DrawText(512, 768, L"Press Alt-F4 to exit...");
      UpdateDisplay();
      Sleep(100);
   }
}
