#include "axbreeze.h"
#include "resource.h"
#define MAX_BUFFER 900*1024 // 900K buffer size
BYTE cbuffer[MAX_BUFFER];
BYTE tbuffer[MAX_BUFFER];

void PrintMusicInfo()
{
   DrawText(1024/2, 20, L"Load and process media from memory and resource");
   DrawText(1024/2, 60, L"Play MIDI music");
   DrawText(300, 100, L"GetMusicLoop() = %d", GetMusicLoop());
   DrawText(300, 150, L"GetMusicPedal() = %d", GetMusicPedal());
   DrawText(300, 200, L"GetMusicVolume() = %d", GetMusicVolume());
   DrawText(300, 250, L"GetMusicFormat() = %d", GetMusicFormat());
   DrawText(300, 300, L"GetMusicTrack() = %d", GetMusicTrack());
   DrawText(300, 350, L"GetMusicBuffer() = %d", GetMusicBuffer());
   DrawText(300, 400, L"GetMusicTick() = %d", GetMusicTick());
   DrawText(512, 728, L"Press Alt-F4 to exit...");
   UpdateDisplay();
}

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   UINT uSize;
   BYTE* pBuffer;

   // Initialize the display
   SetDisplayMode(1024, 768);
   SetForeColor(0xFFFF0000);
   SetBackColor(0xFF0000FF);
   SetTextAlignment(0, 0);
/*
   // Load image into memory
   uSize = LoadFile(cbuffer, MAX_BUFFER, L"..\\Image\\helloworld.jpg");

   // Do some crazy things here (this can be done separately in another file)
   for(UINT i = 0; i < uSize; i++)
   {
      cbuffer[i] = ~cbuffer[i];
   }
   SaveFile(L"..\\Media\\encrypt.uvw", cbuffer, uSize); // Save the encrypted media
   // Note there is a copy of this in folder Media already
*/
   // Load the above resource (already in executable, see "resource.rc")
   uSize = LoadResource(pBuffer, L"ENIMAGE");

   // Restore the orginal media (decrypt it)
   for(UINT i = 0; i < uSize; i++)
   {
      tbuffer[i] = ~pBuffer[i];
   }

   // Load image from memory (the real image is here) and paste image to screen
   HANDLE Image2 = LoadImage(tbuffer, uSize);
   DrawImage(Image2, 192, 144);

/*
   // Do the same to sound, too
   uSize = LoadFile(cbuffer, MAX_BUFFER, L"..\\Sound\\applaud.wav");
   for(UINT i = 0; i < uSize; i++)
   {
      cbuffer[i] = ~cbuffer[i];
   }
   SaveFile(L"..\\Media\\encrypt.xyz", cbuffer, uSize);
*/
   uSize = LoadResource(pBuffer, L"ENSOUND");

   for(UINT i = 0; i < uSize; i++)
   {
      tbuffer[i] = ~pBuffer[i];
   }
   HANDLE hSound0 = LoadSound(tbuffer, uSize);
   PlaySound(hSound0, 2);

   // Load music from resource (already in executable, see "resource.rc")
   HANDLE hMusic0 = LoadMusic(L"LIANGZHU", -1);
   PlayMusic(hMusic0, 1);
   DrawText(1024/2, 100, L"Load and process media from memory and resource");
   DrawText(1024/2, 768/2+100, L"Play MIDI music");
   UpdateDisplay();
   Snooze(5.0f);

   // Enter the main loop
   while(Looping())
   {
      if(GetVirtualKey() || GetMouseButton()) break;
      if(!MusicPlaying()) break;
      ClearDisplay();
      PrintMusicInfo();
      Sleep(10);
   }
   Snooze(5.0f);

   ClearDisplay();
   DrawText(512, 20, L"Test music pause, resume, and stop");
   DrawText(512, 60, L"Call Snooze instead of Sleep for long time idle");
   UpdateDisplay();

   DisableMusicPause(1);

   // Load "diamond.png" to memory
   uSize = LoadFile(cbuffer, MAX_BUFFER, L"..\\Music\\liuyanghe.mid");
   RemoveMusic(hMusic0);
   hMusic0 = LoadMusic(cbuffer, uSize);
   PlayMusic(hMusic0);
   SetMusicVolume(120);
   Snooze(5.0f);

   PauseMusic();
   ClearDisplay();
   DrawText(512, 628, L"PauseMusic() is called...");
   PrintMusicInfo();
   Snooze(5.0f);

   ResumeMusic();
   while(Looping())
   {
      if(GetVirtualKey() || GetMouseButton()) break;
      if(!MusicPlaying()) break;
      ClearDisplay();
      DrawText(512, 628, L"ResumeMusic() is called...");
      PrintMusicInfo();
      Sleep(10);
   }

   StopMusic();
   ClearDisplay();
   DrawText(512, 628, L"StopMusic() is called...");
   UpdateDisplay();
   Snooze(5.0f);

   HANDLE hMusic1 = LoadMusic(L"..\\Music\\muolihua.mid");
   PlayMusic(hMusic1);
   SetMusicVolume(150);
   ClearDisplay();
   DrawText(512, 628, L"Playing new music...");
   PrintMusicInfo();
   Snooze(10.0f);

   HANDLE hMusic2 = LoadMusic(L"..\\Music\\yaolanqu.mid");
   PlayMusic(hMusic2, 2);

   // Enter the main loop
   while(Looping())
   {
      if(!MusicPlaying()) break;
      ClearDisplay();
      PrintMusicInfo();
      Sleep(10);
   }
}
