#include "axbreeze.h"
#include "resource.h"
#define MAX_BUFFER 500*1024 // 500K buffer size

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   SetWindowTitle(L"Sound Engine");

   // Initialize the display
   SetDisplayMode(1024, 768);
   SetForeColor(0xFFFFFF00);
   SetBackColor(0xFF0000FF);
   ClearDisplay(0xFF0000FF);

   SetTextFont(L"Times New Roman");
   SetTextAlignment(0, 0);
   DrawText(1024/2, 768/2, L"Hello, XAudio2!");
   SetTextAlignment(0, 1);
   DrawText(512, 440, L"Click mouse left button or press space bar");
   HANDLE hSound10 = LoadSound(L"..\\Sound\\applaud.wav");
   PlaySound(hSound10, 255);
   UpdateDisplay();

   SetTextAlignment(-1, -1);

   HANDLE hSound1 = LoadSound(L"JACKPOT", -1);

   // Enter the game loop
   while(Looping())
   {
      auto oKey = GetVirtualKey();
      if(oKey)
      {
         ClearDisplay(0xFF0000FF);
         DrawText(100, 40, L"Key pressed = %x", oKey);
      }
      if(PollVirtualKey(VK_SPACE) || GetVirtualKey() == VK_LBUTTON)
      {
         ClearDisplay(0xFF0000FF);
         PauseSound();
         StopSound(hSound10);
         DrawText(100, 100, L"Sound Stopped!");
         DrawText(100, 200, L"Right click to resume");
      }
      if(GetVirtualKey() == VK_RBUTTON)
      {
         ClearDisplay(0xFF0000FF);
         ResumeSound();
         PlaySound(hSound10, 5);
         PlaySound(hSound1, 255);
         ClearDisplay(0xFF0000FF);
         DrawText(100, 100, L"Back to business!");
         DrawText(100, 200, L"Click left button or press space bar");
         Snooze(2.0f);
         break;
      }
      UpdateDisplay(60);
   }

   StopSound(hSound1);
   SetForeColor(0xFFFFFF00);
   SetBackColor(0xFF0000FF);
   ClearDisplay(0xFF0000FF);

   // Load and play mp3 format sound
   HANDLE hSound53 = LoadSound(L"..\\Sound\\tmmpcm.mp3");
   PlaySound(hSound53, 255);

   BYTE oVolume = 100;
   BYTE oPitch = 100;
   char cPan = 0;

   // Enter the game loop
   while(Looping())
   {
      SetTextAlignment(0, 0);
      DrawText(1024/2, 768/2, L"Sound control");
      PrintText(1024/2, 768/2+50, L"Press arrow or control keys \f#ff0000(Escape to Exit)");
      SetTextAlignment(-1, -1);
      if(PollVirtualKey(VK_LEFT))
      {
         ClearDisplay(0xFF0000FF);
         cPan -= 10;
         SetSoundPan(hSound53, cPan);
         DrawText(200, 350, L"Pan %d", cPan);
      }
      if(PollVirtualKey(VK_RIGHT))
      {
         ClearDisplay(0xFF0000FF);
         cPan += 10;
         SetSoundPan(hSound53, cPan);
         DrawText(700, 350, L"Pan %d", cPan);
      }
      if(PollVirtualKey(VK_UP))
      {
         ClearDisplay(0xFF0000FF);
         oVolume += 5;
         SetSoundVolume(hSound53, oVolume);
         DrawText(400, 200, L"Volume %d", oVolume);
      }
      if(PollVirtualKey(VK_DOWN))
      {
         ClearDisplay(0xFF0000FF);
         oVolume -= 5;
         SetSoundVolume(hSound53, oVolume);
         DrawText(400, 500, L"Volume %d", oVolume);
      }
      if(PollVirtualKey(VK_LCONTROL))
      {
         ClearDisplay(0xFF0000FF);
         SetSoundPitch(hSound53, --oPitch);
         DrawText(200, 350, L"Pitch %d", oPitch);
      }
      if(PollVirtualKey(VK_RCONTROL))
      {
         ClearDisplay(0xFF0000FF);
         SetSoundPitch(hSound53, ++oPitch);
         DrawText(200, 350, L"Pitch %d", oPitch);
      }
      if(PollEscapeKey()) break;
      Sleep(100);
      UpdateDisplay();
   }

   ClearDisplay(0xFF0000FF);
   cPan = GetSoundPan(hSound53);
   oVolume = GetSoundVolume(hSound53);
   oPitch = GetSoundPitch(hSound53);
   DrawText(600, 350, L"cPan %d", cPan);
   DrawText(400, 500, L"oVolume %d", oVolume);
   DrawText(200, 350, L"oPitch %d", oPitch);
   SetTextAlignment(0, 0);
   DrawText(1024/2, 700, L"Click mouse to exit");
   UpdateDisplay();
   WaitVirtualKeyDown(5.0f);
}
