﻿#include "axbreeze.h"

struct PROPERTY
{
   WCHAR szName[MAX_PATH];
   WCHAR szFile[MAX_PATH];
   WCHAR szDirectory[MAX_PATH];
   float fDensity;
   double dYoungs_Modulus;
   float fPoissons_Ratio;
   double dYield_Stress;
   float fExpansion_Coefficient;
   BYTE oIndex;
   char cX;
   short sY;
   int iZ;
   BYTE oX;
   WORD wY;
   UINT uZ;
   bool bSwitchAll;
   bool bFile;
   bool bGroup1;
   bool bGroup2;
   bool bRadio1;
   bool bRadio2;
   bool bRadio3;
   bool bTab2;
   bool bRadio5;
   bool bRadio6;
   bool bCheck1;
   bool bCheck2;
   bool bShort;
   bool bInt;
   bool bTab3;
   bool bTab4;
   bool bInvertAll;
   bool bYield_Stress;
   bool bExpansion_Coefficient;
};

bool bPage[3] = { 0 };
PROPERTY aData = { L"Name", L"File", L"Directory", 0, 3.4E-5, 0.3f, 8.5, 9e-6f };

void* pSublevel[] = {
   L"09 List used by another array", // Start of another pointer array
      L"90", // Extra line is needed
      L"00 This is a test to show that another pointer array is used.", // Footnote
      L"88 Young's Modulus [ Pa ]:", // Input is required double data
         &aData.dYoungs_Modulus,
      L"84 Poisson's Ratio:",      // Input is required float data
         &aData.fPoissons_Ratio,
   nullptr };                      // End of dialog box (nullptr)

void* pReplace[] = {
   L"Get Input Data",              // Dialog box title (no leading hexadecimal number)
      L"00 This is a test to show that dialog window is replaced by a callback function.", // Footnote
      L"00", // Extra line is needed
      L"04 Density [ kg/m^3 ]:",     // Input is required float data
         &aData.fDensity,
      L"09 Sublevel array",   // Input is required pointer array
         pSublevel,
      L"98 Yield Stress [ Pa ]:",    // Input is optional double data
         &aData.bYield_Stress,
         &aData.dYield_Stress,
      L"14 Expansion Coefficient [ K_21^2 ]:", // Input is optional float data
         &aData.bExpansion_Coefficient,
         &aData.fExpansion_Coefficient,
   nullptr };                      // End of dialog box (nullptr)

bool InputDialogArrowCallback(HWND hParent)
{
   MessageBox(hParent, L"InputDialogArrowCallback!", L"Arrow Callback", MB_ICONINFORMATION | MB_OK);
   ResetInputData(pReplace, nullptr, 1);
   return 1;
}

bool InputDialogApplyCallback(HWND hParent)
{
   MessageBox(hParent, L"InputDialogApplyCallback!", L"Apply Button", MB_ICONINFORMATION | MB_OK);
   aData.oIndex = 1;
   aData.cX = 10;
   aData.sY = 20;
   aData.iZ = 30;
   return 1;
}

void* pMechanical[] = {
   L"Get Input Data",              // Dialog box title (no leading hexadecimal number)
      L"E0 Tab page 1",            // Tab page 1
         L"70 Group box 1",        // Group box 1
            &aData.bGroup1,
            L"40 Switch All",      // Check box for activated selection (with leading hexadecimal number)
               &aData.bSwitchAll,
            L"8E Name:",           // Input is required text string
               &aData.szName,
            L"8D Directory:",      // Input is required directory
               &aData.szDirectory,
            L"9F File:",           // Button tooltip (with leading hexadecimal number)
               &aData.bFile,
               &aData.szFile,
         nullptr,                  // End of group box (nullptr)
         L"70 Group box 2",        // Group box 2
            &aData.bGroup2,
            L"20 Radio 1",         // Radio button
               &aData.bRadio1,
            L"20 Radio 2",         // Radio button
               &aData.bRadio2,
            L"20 Radio 3",         // Radio button
               &aData.bRadio3,
         nullptr,                  // End of group box (nullptr)
      nullptr,                     // End of tab page (nullptr)
      L"D0 Tab page 2",            // Tab page 2
         &aData.bTab2,
         L"80 Group box 3",        // Group box 3
            L"00 This is a test to show that static control text can be drawn in multiple lines.", // Footnote
               L"00 Second line is combined.\n", // Footnote (with extra lines)
            L"8C Combobox:",       // Input is required combobox control
               &aData.oIndex,
               L"Item 0",
               L"Item 1",
               L"Item 2",
               L"Item 3",
            nullptr,
            L"B0 Row of buttons:", // Input is a row of buttons
               L"20 Radio 5",      // Radio button
                  &aData.bRadio5,
               L"30 Radio 6",      // Radio button
                  &aData.bRadio6,
               L"10 Check 1",      // Check box
                  &aData.bCheck1,
               L"10 Check 2",      // Check box
                  &aData.bCheck2,
            nullptr,
            L"72 2D (short):",     // Input is required short data
               &aData.bShort,
               &aData.sY,
            L"F3 3D (int):",       // Input is optional integer data
               &aData.bInt,
               &aData.iZ,
            L"A0 Input dialog arrow callback",
               InputDialogArrowCallback,
            L"F0 Apply Button",
               InputDialogApplyCallback,
         nullptr,                  // End of group box (nullptr)
      nullptr,                     // End of tab page (nullptr)
      L"D0 Tab page 3",            // Tab page 3
         &aData.bTab3,
         L"80",                    // Group box 4
            L"90 This is a test to show that static control text can be drawn in ", // Footnote
               L"90 multiple lines. Second line is here with _{subscript} and ^{superscript}.", // Footnote (with 1 extra line)
            L"01 Integer (char):",  // Input is required char data
               &aData.cX,
            L"82 Integer (short):", // Input is required short data
               &aData.sY,
            L"83 Integer (int):",   // Input is required integer data
               &aData.iZ,
            L"09 Sublevel array",   // Input is required pointer array
               pSublevel,
         nullptr,                   // End of group box (nullptr)
      nullptr,                      // End of tab page (nullptr)
      L"C0 Tab page 4",             // Tab page 4
         &aData.bTab4,
         L"80 Group box 4",         // Group box 4
            L"50 Invert All",       // Check box for inverted selection
               &aData.bInvertAll,
            L"05 Integer (BYTE):", // Input is required unsigned char data
               &aData.oX,
            L"86 Integer (WORD):", // Input is required unsigned short data
               &aData.wY,
            L"87 Integer (UINT):", // Input is required unsigned integer data
               &aData.uZ,
            L"09 Sublevel array",   // Input is required pointer array
               pSublevel,
         nullptr,                  // End of group box (nullptr)
      nullptr,                     // End of tab page (nullptr)
   nullptr };                      // End of dialog box (nullptr)

WCHAR* CheckMaterialProperty()
{
   return aData.fDensity <= 0.0 ? L"Density must be positive!" : nullptr;
}

void MenuCallbackGetInput()
{
   GetInputData(10, 10, pMechanical, CheckMaterialProperty);
}

void* ppEdit[];

WCHAR* pAbout = L"This window shows marked-up text\n"
                L"<A HREF=\"mailto:info@nodapro.com\">Email: info@nodapro.com</A>\n"
                L"<A HREF=\"http://www.nodapro.com\">www.nodapro.com</A>";

void MenuCallbackAbout()
{
   ShowAboutDialog(80, 5, 300, 200, L"About", pAbout);
}

// State hexadecimal number meaning (for menu item callback)
// 0x20 = Mouse left button clicked (input only)
// 0x10 = Disable the menu item and gray it so that it cannot be selected
// 0x08 = Place a check mark next to the menu item

void MenuCallbackNew(AXMITE& aMite)
{
   aMite.m ^= UI_CHECKED;
   if(aMite.m & UI_CHECKED)
   {
      SpeakText(L"New menu checked!");
      EnableMainMenuItem((WCHAR*)ppEdit[0], 3, 5, 0);
   }
   else
   {
      SpeakText(L"New menu unchecked!");
     EnableMainMenuItem((WCHAR*)ppEdit[0], 3, 5, 1);
   }
   MenuCallbackGetInput();
}

void MenuCallbackOpen(AXMITE& aMite)
{
   if(aMite.m & UI_CALLBACK)
   {
      SpeakText(L"Mouse left button clicked!");
   }

   if(aMite.m & UI_COLORED)
   {
      aMite.m &= ~UI_COLORED;
      SpeakText(L"Open menu enabled!");
   }
   else if(!(aMite.m & UI_COLORED))
   {
      aMite.m |= UI_COLORED;
      SpeakText(L"Open menu grayed!");
   }
}

void MenuCallbackSave(AXMITE&)
{
   SpeakText(L"Save menu selected!");
}

void MenuCallbackSaveAs(AXMITE&)
{
   SpeakText(L"Save As menu selected!");
}

void MenuCallbackSaveAll(AXMITE&)
{
   SpeakText(L"Save All menu selected!");
}

void MenuCallbackSubmenu(AXMITE&)
{
   SpeakText(L"Submenu selected!");
}

void MenuCallbackExit(AXMITE&)
{
   SpeakText(L"Exit menu selected!");
   DestroyDisplay();
}

// State hexadecimal number meaning (for toolbar button callback)
// 0x20 = Mouse left button clicked (input only)
// 0x10 = Disable the button and gray it
// 0x08 = Button is being clicked

void ButtonCallbackNew(AXMITE& aMite)
{
   aMite.t ^= UI_CHECKED;
   if(aMite.t & UI_CHECKED)
   {
      SpeakText(L"New button checked!");
   }
   else
   {
      SpeakText(L"New button unchecked!");
   }
}

void ButtonCallbackOpen(AXMITE& aMite)
{
   if(aMite.t & UI_CALLBACK)
   {
      SpeakText(L"Mouse left button clicked!");
   }

   if(aMite.t & UI_COLORED)
   {
      aMite.t &= ~UI_COLORED;
      SpeakText(L"Open button enabled!");
   }
   else if(!(aMite.t & UI_COLORED))
   {
      aMite.t |= UI_COLORED;
      SpeakText(L"Open button grayed!");
   }
}

void ButtonCallbackClose(AXMITE& aMite)
{
   aMite.t ^= UI_CHECKED;
   if(aMite.t & UI_CHECKED)
   {
      SpeakText(L"Close button checked!");
   }
   else
   {
      SpeakText(L"Close button unchecked!");
   }
}

void ButtonCallbackUndo(AXMITE& aMite)
{
   aMite.t ^= UI_CHECKED;
   if(aMite.t & UI_CHECKED)
   {
      SpeakText(L"Undo button checked!");
   }
   else
   {
      SpeakText(L"Undo button unchecked!");
   }
}

void ButtonCallbackRedo(AXMITE& aMite)
{
   if(aMite.t & UI_CALLBACK)
   {
      SpeakText(L"Mouse left button clicked!");
   }

   if(aMite.t & UI_COLORED)
   {
      aMite.t &= ~UI_COLORED;
      SpeakText(L"Redo button enabled!");
   }
   else if(!(aMite.t & UI_COLORED))
   {
      aMite.t |= UI_COLORED;
      SpeakText(L"Redo button grayed!");
   }
}

void ButtonCallbackHome(AXMITE& aMite)
{
   aMite.t ^= UI_CHECKED;
   if(aMite.t & UI_CHECKED)
   {
      SpeakText(L"Home button checked!");
      ShellExecute(nullptr, L"open", L"http://www.nodapro.com", nullptr, nullptr, SW_SHOWNORMAL);
   }
   else
   {
      SpeakText(L"Home button unchecked!");
   }
}

// Leading hexadecimal number meaning (for menu items only)
// 0x80 = Specify that this is the default menu item for the specified menu
// 0x40 = Check the specified menu item and make it a radio item
// 0x20 = Specify that a callback function is provided
// 0x10 = Disable the menu item and gray it so that it cannot be selected
// 0x08 = Place a check mark next to the menu item
// 0x04 = Specify that a custom unchecked bitmap is provided
// 0x02 = Specify that a custom checked bitmap is provided
// 0x01 = Create a submenu associated with the menu item

void* ppFile[] = {
   L"&File",                          // Menu name (no leading hexadecimal number)
      L"20 &New\tCtrl+N",             // Callback function is provided
         MenuCallbackNew,     // Function address (no leading hexadecimal number)
      L"28 &Open\tCtrl+O",            // CHECKED
         MenuCallbackOpen,    // Function address (no leading hexadecimal number)
      L"--",                          // SEPARATOR
      L"20 &Save\tCtrl+S",
         MenuCallbackSave,    // Function address (no leading hexadecimal number)
      L"20 Save As...\tAlt+Shift+S",
         MenuCallbackSaveAs,  // Function address (no leading hexadecimal number)
      L"28 Save All\tCtrl+Enter",
         MenuCallbackSaveAll, // Function address (no leading hexadecimal number)
      L"--",                          // SEPARATOR
      L"28 &Exit\tAlt+F4",
         MenuCallbackExit,    // Function address (no leading hexadecimal number)
   nullptr };                            // End of menu (nullptr)

void* ppEdit[] = {
   L"&Edit",                                // Menu name (no leading hexadecimal number)
      L"10 &Undo\tCtrl+Z",                  // GRAYED
      L"10 &Redo\tCtrl+Y",                  // GRAYED
      L"--",                                // SEPARATOR
      L"00 Cut\tCtrl+X",
      L"00 Copy\tCtrl+C",
      L"00 Paste\tCtrl+V",
      L"--",                                // SEPARATOR
      L"01 Select",                         // Submenu name (with leading hexadecimal number)
         L"00 Select All\tCtrl+A",          // Submenu item
         L"00 Select Line\tCtrl+E",         // Submenu item
         L"00 Select Word\tCtrl+D",         // Submenu item
         L"00 Select Block\tCtrl+B",        // Submenu item
      nullptr,                                 // End of submenu (nullptr)
      L"09 Change Case",                    // Submenu name (with leading hexadecimal number)
         L"00 Upper Case\tCtrl+U",
         L"00 Lower Case\tCtrl+L",
         L"09 Second Level",                // Submenu name (second level)
            L"28 Submenu Item\tCtrl+F5",    // Submenu item (callback function is provided)
               MenuCallbackSubmenu, // Function address (no leading hexadecimal number)
            L"20 Submenu Test\tF5",         // Submenu test (same callback function is used)
               MenuCallbackSubmenu, // Function address (no leading hexadecimal number)
         nullptr,                              // End of submenu (second level)
         L"00 Capitalize\tCtrl+Shift+U",
         L"00 Invert Case\tCtrl+Shift+L",
      nullptr,                                 // End of submenu (nullptr)
      L"00 Column Mode\tAlt+C",
   nullptr };                                  // End of menu (nullptr)

void* ppSearch[] = {
   L"&Search",                   // Menu name (no leading hexadecimal number)
      L"00 Find...\tCtrl+F",
      L"00 Replace...\tCtrl+H",
      L"--",                     // SEPARATOR
      L"00 Find Next\tF3",
      L"00 Find Prev\tShift+F3",
   nullptr };                       // End of menu (nullptr)

void** pppMenu[] = { ppFile, ppEdit, ppSearch, nullptr };

// Leading hexadecimal number meaning (for toolbar buttons)
// 0x80 = Specify that the button automatically toggles between states
// 0x40 = Add a popup menu associated with the button right mouse click
// 0x20 = Specify that a callback function is provided
// 0x10 = Disable the button and gray it
// 0x08 = Button is being clicked (pressed)
// 0x04 = Add a bitmap to the button
// 0x02 = Specify that the bitmap is internal
// 0x01 = Reserved

void* ppButton[] = {
   L"Toolbar",                        // Toolbar name (no leading hexadecimal number)
      L"26 New",                      // Button tooltip (with leading hexadecimal number)
         ButtonCallbackNew,   // Function address (no leading hexadecimal number)
         (void*)STD_FILENEW,         // Common control library image (defined in commctrl.h)
      L"26 Open",                     // Button tooltip (with leading hexadecimal number)
         ButtonCallbackOpen,  // Function address (no leading hexadecimal number)
         (void*)STD_FILEOPEN,
      L"24 Close",                    // Button tooltip (with leading hexadecimal number)
         ButtonCallbackClose, // Function address (no leading hexadecimal number)
         L"IMG_16_CLOSE",             // Button image resource name (defined in resource.rc)
      L"06 Save",                     // Button tooltip (with leading hexadecimal number)
         (void*)STD_FILESAVE,
      L"04 Save All",                 // Button tooltip (with leading hexadecimal number)
         L"IMG_16_SAVEALL",
      L"--",                          // SEPARATOR
      L"06 Print",                    // Button tooltip (with leading hexadecimal number)
         (void*)STD_PRINT,
      L"06 Print Preview",            // Button tooltip (with leading hexadecimal number)
         (void*)STD_PRINTPRE,
      L"--",                          // SEPARATOR
      L"06 Cut",                      // Button tooltip (with leading hexadecimal number)
         (void*)STD_CUT,
      L"06 Copy",                     // Button tooltip (with leading hexadecimal number)
         (void*)STD_COPY,
      L"06 Paste",                    // Button tooltip (with leading hexadecimal number)
         (void*)STD_PASTE,
      L"--",                          // SEPARATOR
      L"2E Undo",                     // Button tooltip (with leading hexadecimal number)
         ButtonCallbackUndo,  // Function address (no leading hexadecimal number)
         (void*)STD_UNDO,
      L"27 Redo",                     // Button tooltip (with leading hexadecimal number)
         ButtonCallbackRedo,  // Function address (no leading hexadecimal number)
         (void*)STD_REDOW,
      L"06 Delete",                   // Button tooltip (with leading hexadecimal number)
         (void*)STD_DELETE,
      L"--",                          // SEPARATOR
      L"06 Find",                     // Button tooltip (with leading hexadecimal number)
         (void*)STD_FIND,
      L"06 Replace",                  // Button tooltip (with leading hexadecimal number)
         (void*)STD_REPLACE,
      L"04 Star",                     // Button tooltip (with leading hexadecimal number)
         L"IMG_16_STAR",
      L"04 Tick",                     // Button tooltip (with leading hexadecimal number)
         L"IMG_16_TICK",
      L"04 Wand",                     // Button tooltip (with leading hexadecimal number)
         L"IMG_16_WAND",
      L"04 Zoom",                     // Button tooltip (with leading hexadecimal number)
         L"IMG_16_ZOOM",
      L"--",                          // SEPARATOR
      L"06 Properties",               // Button tooltip (with leading hexadecimal number)
         (void*)STD_PROPERTIES,
      L"26 Help",                     // Button tooltip (with leading hexadecimal number)
         MenuCallbackAbout,
         (void*)STD_HELP,
      L"24 Home",                     // Button tooltip (with leading hexadecimal number)
         ButtonCallbackHome,  // Function address (no leading hexadecimal number)
         L"IMG_16_HOME",
   nullptr };                            // End of toolbar (nullptr)

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   EnableSmallIcon(1);

   WORD wWidth = 640, wHeight = 480;

   SetDisplayMode(wWidth, wHeight, 1);

   // Call these functions before SetDisplayMode
   AppendMainMenu(ppFile, ppEdit, ppSearch, nullptr);
   SetWindowToolbar(ppButton);
   //InsertMainMenu(pppMenu, 1);

   aData.oIndex = 1;
   aData.bSwitchAll = 1;
   aData.bRadio1 = 1;
   aData.bTab2 = 1;
   aData.bRadio6 = 1;
   aData.bCheck2 = 1;
   aData.bTab4 = 1;
   aData.bGroup2 = 1;

   // Enter the game loop
   while(Looping())
   {
      ClearDisplay(0xFF0000FF);
      DrawText(wWidth/2, wHeight/2, 0, 0, GetWorkDirectory());
      UpdateDisplay();
      Sleep(50);
   }
}
